// GBALib
// v. 00.11.25 wip
// /Mic, 2000
//



// [graphics modes]
#define _240x160x1x256_		0x04
#define _240x160x0x32k_		0x03


// [palettes]
#define BACKGROUND	0x05000000
#define OBJECT		0x05000200

#define VRAM 		0x06000000

#define FOCAL 256.0f

// [shade models]
#define GBAL_FLAT 0
#define GBAL_SMOOTH 1

#define GBAL_TEXTURE_2D     0x01


typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;



typedef struct POINT
{
  long x, y;
  long c;
  long u,v;
}POINT;


struct RContext
{
 u8 *buffer;
 u32 width;
 u32 height;
 u8 bitspp;
}RContext;

struct gbal_texture
{
 void *texture;
 u32 width;
 u32 height;
}gbal_texture;


// data for Draw?Section?()
struct dsdata
{
 long x1,x2;
 long y1,y2;
 long c1,c2;
 long red1,red2, green1,green2, blue1,blue2;
 long u1,u2, v1,v2;
 long dxdy1,dxdy2;
 long dcdy1,dcdy2;
 long drdy1,drdy2,dgdy1,dgdy2,dbdy1,dbdy2;
 long dudy1,dudy2,dvdy1,dvdy2;
}dsdata;


//void *current_texture;
long gbal_stack[32];
u8 stackptr = 31;

typedef void (*tri_func)(POINT *pp1, POINT *pp2, POINT *pp3);
tri_func GouraudTriangle;
tri_func TextureTriangle;
tri_func gbalTriangle, last_gbalTriangle;
void (*DrawSection)(void);
void (*gbalBlit)(long x,long y,long xdim,long ydim,void *src,u16 rastop);


/*
void _push(long val)
{
  if (stackptr!=0)
  {
    gbal_stack[stackptr] = val;
    stackptr--;
 }
}

long _pop()
{
  if (stackptr<31)
  {
    stackptr++;
    return gbal_stack[stackptr];
  }
}
*/


void srccopy8(long x, long y, long xdim, long ydim, void *src)
{
__asm
{
 mov r0,#240
 mov r1,y
 mul r1,r0,r1
 mov r0,x
 add r1,r1,r0
 mov r0,#0x06000000
 add r0,r0,r1

 // r3 = 240 - x
 mov r2,src
 mov r3,#240
 mov r4,xdim
 sub r3,r3,r4

 mov r4,ydim
 Yloop8:
  mov r5,xdim
  mov r6,r5,lsr #2
  and r5,r5,#3
  Xloop8:
   ldr r1,[r2],#4
   str r1,[r0],#4
   // The 's'-suffix is neccecary to update the flags, or you'd get an
   // eternal loop..
   subs r6,r6,#1
  bne Xloop8
  cmp r5,#0
  beq noRest
  drawRest:
    ldrb r1,[r2],#1
    strb r1,[r0],#1
    subs r5,r5,#1
  bne drawRest
  noRest:
  add r0,r0,r3
  subs r4,r4,#1
 bne Yloop8
}
}


void notnullcopy8(long x, long y, long xdim, long ydim, void *src)
{
__asm
{
 mov r0,#240
 mov r1,y
 mul r1,r0,r1
 mov r0,x
 add r1,r1,r0
 mov r0,#0x06000000
 add r0,r0,r1

 // r3 = 240 - x
 mov r2,src
 mov r3,#240
 mov r4,xdim
 sub r3,r3,r4

 mov r4,ydim
 Yloop8:
  mov r5,xdim
  Xloop8:
   ldrb r1,[r2]
   orrs r1,r1,r1
   beq invisible
   strb r1,[r0]
   invisible: 
   add r2,r2,#1
   add r0,r0,#1
   // The 's'-suffix is neccecary to update the flags, or you'd get an
   // eternal loop..
   subs r5,r5,#1
  bne Xloop8
  add r0,r0,r3
  subs r4,r4,#1
 bne Yloop8
}
}


void srccopy15(long x, long y, long xdim, long ydim, void *src)
{
__asm
{
 mov r0,#480
 mov r1,y
 mul r1,r0,r1
 mov r0,x
 add r1,r1,r0
 add r1,r1,r0
 mov r0,#0x06000000
 add r0,r0,r1

 // r3 = (240*2) - (x*2)
 mov r2,src
 mov r3,#480
 mov r4,xdim
 sub r3,r3,r4
 sub r3,r3,r4

 mov r4,ydim
 Yloop15:
  mov r5,xdim
  Xloop15:
   // Move a half-word (16 bits) from [r2] to [r0]
   ldrh r1,[r2]
   strh r1,[r0]

   add r2,r2,#2
   add r0,r0,#2

   // The 's'-suffix is neccecary to update the flags, or you'd get an
   // eternal loop..
   subs r5,r5,#1
  bne Xloop15
  add r0,r0,r3
  subs r4,r4,#1
 bne Yloop15
}
}



// Internal function, don't call this one.
void DrawSection8()
{
u32 y;
long x1,x2;
u8 *dest,*last_dest, col;
long clipped;
  if (dsdata.y1 >= RContext.height) return;
  if (dsdata.y2 < 0) return;

  col = (u8)(dsdata.c1);
  if (dsdata.y1<0)  
  {
    clipped = 0-dsdata.y1;
    dsdata.x1 += (dsdata.dxdy1*clipped);
    dsdata.x2 += (dsdata.dxdy2*clipped);
    dsdata.y1 = 0;
  }
  if (dsdata.y2 >= RContext.height) dsdata.y2 = (RContext.height-1);
  dest = (RContext.buffer + (dsdata.y1*RContext.width));

  for (y=dsdata.y1; y<=dsdata.y2; y++)  
  {
    if (dsdata.x1 <= dsdata.x2)
    {
      x1 = dsdata.x1;
      x2 = dsdata.x2;
    }else
    {
      x1 = dsdata.x2;
      x2 = dsdata.x1;
    }
    x1 >>= 9;
    x2 >>= 9;
    if ((x1<RContext.width)&&(x2>=0))
    {
      last_dest = dest;
      dest += x1;
      __asm
      {
        mov r0,dest
        mov r1,x2
        mov r2,x1
        sub r1,r1,r2
        add r1,r1,#1
        mov r2,col
        Store8:
          strb r2,[r0]
          add r0,r0,#1
          subs r1,r1,#1
        bne Store8
      }
      dest = last_dest;
    } 
    if (y<dsdata.y2)
    {
      dest += RContext.width;
      dsdata.x1 += dsdata.dxdy1;
      dsdata.x2 += dsdata.dxdy2;
    }
  }
}


// Internal function, don't call this one.
void DrawSection15()
{
u32 y;
long x1,x2;
u16 *dest,*last_dest, col;
long clipped;
  if (dsdata.y1 >= RContext.height) return;
  if (dsdata.y2 < 0) return;

  col = (u16)(dsdata.c1);
  if (dsdata.y1<0)  
  {
    clipped = 0-dsdata.y1;
    dsdata.x1 += (dsdata.dxdy1*clipped);
    dsdata.x2 += (dsdata.dxdy2*clipped);
    dsdata.y1 = 0;
  }
  if (dsdata.y2 >= RContext.height) dsdata.y2 = (RContext.height-1);
  dest = ((u16 *)(RContext.buffer) + (dsdata.y1*RContext.width));

  for (y=dsdata.y1; y<=dsdata.y2; y++)  
  {
    if (dsdata.x1 <= dsdata.x2)
    {
      x1 = dsdata.x1;
      x2 = dsdata.x2;
    }else
    {
      x1 = dsdata.x2;
      x2 = dsdata.x1;
    }
    x1 >>= 9;
    x2 >>= 9;
    if ((x1<RContext.width)&&(x2>=0))
    {
      last_dest = dest;
      dest += x1;
      __asm
      {
        mov r0,dest
        mov r1,x2
        mov r2,x1
        sub r1,r1,r2
        add r1,r1,#1
        mov r2,col
        Store16:
          strh r2,[r0]
          add r0,r0,#2
          subs r1,r1,#1
        bne Store16
      }
      dest = last_dest;
    } 
    if (y<dsdata.y2)
    {
      dest += RContext.width;
      dsdata.x1 += dsdata.dxdy1;
      dsdata.x2 += dsdata.dxdy2;
    }
  }
}




// Draw a single-coloured triangle.
void Triangle(POINT *pp1, POINT *pp2, POINT *pp3)
{
POINT *pp4;
long dx1,dx2,dx3;
long dy1,dy2,dy3;
long dxdy1,dxdy2,dxdy3;

  if (pp2->y < pp1->y) { pp4=pp1; pp1=pp2; pp2=pp4; }
  if (pp3->y < pp1->y) { pp4=pp1; pp1=pp3; pp3=pp4; }
  if (pp3->y < pp2->y) { pp4=pp2; pp2=pp3; pp3=pp4; }

  dx1 = (pp2->x - pp1->x);
  dx2 = (pp3->x - pp2->x);
  dx3 = (pp3->x - pp1->x);

  dy1 = (pp2->y - pp1->y);
  dy2 = (pp3->y - pp2->y);
  dy3 = (pp3->y - pp1->y);
  if (dy1==0) dy1++;
  if (dy2==0) dy2++;
  if (dy3==0) dy3++;

  dxdy1 = ((dx1<<9)/dy1);
  dxdy2 = ((dx2<<9)/dy2);
  dxdy3 = ((dx3<<9)/dy3);

  dsdata.c1 = pp1->c;

  dsdata.x1 = (pp1->x<<9);
  dsdata.x2 = dsdata.x1;
  dsdata.y1 = pp1->y;
  dsdata.y2 = pp2->y;
  dsdata.dxdy1 = dxdy1;
  dsdata.dxdy2 = dxdy3;

  DrawSection();
  dsdata.y1 = pp2->y;
  dsdata.y2 = pp3->y;
  dsdata.x1 = (pp2->x<<9);
  dsdata.dxdy1 = dxdy2;
  dsdata.dxdy2 = dxdy3;
  DrawSection();
}


// Internal function, don't call this one.
void DrawGSection8()
{
u32 y;
long x1,x2, tmp, dcdx;
long c1,c2;
u8 *dest,*last_dest;
long clipped;
  if (dsdata.y1>=RContext.height) return;
  if (dsdata.y2<0) return;

  if (dsdata.y1<0)  
  {
    clipped = 0-dsdata.y1;
    dsdata.x1 += (dsdata.dxdy1*clipped);
    dsdata.x2 += (dsdata.dxdy2*clipped);
    dsdata.c1 += (dsdata.dcdy1*clipped);
    dsdata.c2 += (dsdata.dcdy2*clipped);
    dsdata.y1 = 0;
  }
  if (dsdata.y2>=RContext.height) dsdata.y2 = (RContext.height-1);
  dest = (RContext.buffer + (dsdata.y1*RContext.width));

  for (y=dsdata.y1; y<=dsdata.y2; y++)  
  {
    if (dsdata.x1 <= dsdata.x2)
    {
      x1 = dsdata.x1;
      x2 = dsdata.x2;
      c1 = dsdata.c1;
      c2 = dsdata.c2;
    }else
    {
      x1 = dsdata.x2;
      x2 = dsdata.x1;
      c1 = dsdata.c2;
      c2 = dsdata.c1;
    }
    x1 >>= 9;
    x2 >>= 9;
    if ((x1<RContext.width)&&(x2>=0))
    {
      last_dest = dest;
      tmp = (x2-x1);
      if (tmp==0) tmp++;
      dcdx = ((c2-c1)/tmp);
      dest += x1;
      __asm
      {
        mov r0,dest
        mov r1,x2
        mov r2,x1
        sub r1,r1,r2
        add r1,r1,#1
        mov r2,c1
        mov r3,dcdx
        Inner:
          mov r4,r2,lsr #16     // r4 = SHR(r2,16)
          strb r4,[r0]
          subs r1,r1,#1
          add r0,r0,#1
          add r2,r2,r3
        bne Inner
      }
      dest = last_dest;
    } 
    if (y<dsdata.y2)
    {
      dest += RContext.width;
      dsdata.x1 += dsdata.dxdy1;
      dsdata.x2 += dsdata.dxdy2;
      dsdata.c1 += dsdata.dcdy1;
      dsdata.c2 += dsdata.dcdy2;
    }
  }
}


// Internal function, don't call this one.
void DrawGSection15()
{
u32 y;
long x1,x2, tmp, drdx,dgdx,dbdx;
long red1,red2, green1,green2, blue1,blue2;
u16 *dest,*last_dest;
long clipped;
  if (dsdata.y1>=RContext.height) return;
  if (dsdata.y2<0) return;

  if (dsdata.y1<0)  
  {
    clipped = 0-dsdata.y1;
    dsdata.x1 += (dsdata.dxdy1*clipped);
    dsdata.x2 += (dsdata.dxdy2*clipped);
    dsdata.red1 += (dsdata.drdy1*clipped);
    dsdata.red2 += (dsdata.drdy2*clipped);
    dsdata.green1 += (dsdata.dgdy1*clipped);
    dsdata.green2 += (dsdata.dgdy2*clipped);
    dsdata.blue1 += (dsdata.dbdy1*clipped);
    dsdata.blue2 += (dsdata.dbdy2*clipped);
    dsdata.y1 = 0;
  }
  if (dsdata.y2>=RContext.height) dsdata.y2 = (RContext.height-1);
  dest = ((u16 *)(RContext.buffer) + (dsdata.y1*RContext.width));

  for (y=dsdata.y1; y<=dsdata.y2; y++)  
  {
    if (dsdata.x1 <= dsdata.x2)
    {
      x1 = dsdata.x1;
      x2 = dsdata.x2;
      red1 = dsdata.red1;
      red2 = dsdata.red2;
      green1 = dsdata.green1;
      green2 = dsdata.green2;
      blue1 = dsdata.blue1;
      blue2 = dsdata.blue2;
    }else
    {
      x1 = dsdata.x2;
      x2 = dsdata.x1;
      red1 = dsdata.red2;
      red2 = dsdata.red1;
      green1 = dsdata.green2;
      green2 = dsdata.green1;
      blue1 = dsdata.blue2;
      blue2 = dsdata.blue1;
    }
    x1 >>= 9;
    x2 >>= 9;
    if ((x1<RContext.width)&&(x2>=0))
    {
      last_dest = dest;
      tmp = (x2-x1);
      if (tmp==0) tmp++;
      drdx = ((red2-red1)/tmp);
      dgdx = ((green2-green1)/tmp);
      dbdx = ((blue2-blue1)/tmp);
      dest += x1;
      __asm
      {
        mov r0,dest
        mov r1,x2
        mov r2,x1
        sub r1,r1,r2
        add r1,r1,#1
        mov r2,red1
        mov r3,drdx
        mov r4,green1
        mov r5,blue1
 
        Inner15:
          mov r6,r2,lsr #16     // r6 = SHR(r2,16)
          mov r7,r4,lsr #11
          and r7,r7,#992
          add r6,r6,r7
          mov r7,r5,lsr #6
          and r7,r7,#31744
          add r6,r6,r7
          strh r6,[r0]
          add r0,r0,#2 
          add r2,r2,r3
          mov r6,dgdx
          mov r7,dbdx
          add r4,r4,r6
          add r5,r5,r7
          subs r1,r1,#1
        bne Inner15
      }
      dest = last_dest;
    } 
    if (y<dsdata.y2)
    {
      dest += RContext.width;
      dsdata.x1 += dsdata.dxdy1;
      dsdata.x2 += dsdata.dxdy2;
      dsdata.red1 += dsdata.drdy1;
      dsdata.red2 += dsdata.drdy2;
      dsdata.green1 += dsdata.dgdy1;
      dsdata.green2 += dsdata.dgdy2;
      dsdata.blue1 += dsdata.dbdy1;
      dsdata.blue2 += dsdata.dbdy2;
    }
  }
}


// Draw a gouraudshaded triangle. 
void GouraudTriangle8(POINT *pp1, POINT *pp2, POINT *pp3)
{
POINT *pp4;
long dx1,dx2,dx3;
long dy1,dy2,dy3;
long dc1,dc2,dc3;
long dxdy1,dxdy2,dxdy3;
long dcdy1,dcdy2,dcdy3;

  if (pp2->y < pp1->y) { pp4=pp1; pp1=pp2; pp2=pp4; }
  if (pp3->y < pp1->y) { pp4=pp1; pp1=pp3; pp3=pp4; }
  if (pp3->y < pp2->y) { pp4=pp2; pp2=pp3; pp3=pp4; }

  dx1 = (pp2->x - pp1->x);
  dx2 = (pp3->x - pp2->x);
  dx3 = (pp3->x - pp1->x);

  dy1 = (pp2->y - pp1->y);
  dy2 = (pp3->y - pp2->y);
  dy3 = (pp3->y - pp1->y);
  if (dy1==0) dy1++;
  if (dy2==0) dy2++;
  if (dy3==0) dy3++;

  dc1 = (pp2->c - pp1->c);
  dc2 = (pp3->c - pp2->c);
  dc3 = (pp3->c - pp1->c);

  dxdy1 = ((dx1<<9)/dy1);
  dxdy2 = ((dx2<<9)/dy2);
  dxdy3 = ((dx3<<9)/dy3);

  dcdy1 = ((dc1<<16)/dy1);
  dcdy2 = ((dc2<<16)/dy2);
  dcdy3 = ((dc3<<16)/dy3);

  dsdata.x1 = (pp1->x<<9);
  dsdata.x2 = dsdata.x1;
  dsdata.c1 = (pp1->c<<16);
  dsdata.c2 = dsdata.c1;
  dsdata.y1 = pp1->y;
  dsdata.y2 = pp2->y;
  dsdata.dxdy1 = dxdy1;
  dsdata.dxdy2 = dxdy3;
  dsdata.dcdy1 = dcdy1;
  dsdata.dcdy2 = dcdy3;

  DrawGSection8();
  dsdata.y1 = pp2->y;
  dsdata.y2 = pp3->y;
  dsdata.x1 = (pp2->x<<9);
  dsdata.c1 = (pp2->c<<16);
  dsdata.dxdy1 = dxdy2;
  dsdata.dxdy2 = dxdy3;
  dsdata.dcdy1 = dcdy2;
  dsdata.dcdy2 = dcdy3;
  DrawGSection8();
}



void GouraudTriangle15(POINT *pp1, POINT *pp2, POINT *pp3)
{
POINT *pp4;
long dx1,dx2,dx3;
long dy1,dy2,dy3;
long dr1,dr2,dr3;
long dg1,dg2,dg3;
long db1,db2,db3;
long dxdy1,dxdy2,dxdy3;
long drdy1,drdy2,drdy3;
long dgdy1,dgdy2,dgdy3;
long dbdy1,dbdy2,dbdy3;
long red1,red2,red3;
long green1,green2,green3;
long blue1,blue2,blue3;

  if (pp2->y < pp1->y) { pp4=pp1; pp1=pp2; pp2=pp4; }
  if (pp3->y < pp1->y) { pp4=pp1; pp1=pp3; pp3=pp4; }
  if (pp3->y < pp2->y) { pp4=pp2; pp2=pp3; pp3=pp4; }

  dx1 = (pp2->x - pp1->x);
  dx2 = (pp3->x - pp2->x);
  dx3 = (pp3->x - pp1->x);

  dy1 = (pp2->y - pp1->y);
  dy2 = (pp3->y - pp2->y);
  dy3 = (pp3->y - pp1->y);
  if (dy1==0) dy1++;
  if (dy2==0) dy2++;
  if (dy3==0) dy3++;

  red1 = (pp1->c&31);
  red2 = (pp2->c&31);
  red3 = (pp3->c&31);
  green1 = ((pp1->c>>5)&31);
  green2 = ((pp2->c>>5)&31);
  green3 = ((pp3->c>>5)&31);
  blue1 = ((pp1->c>>10)&31);
  blue2 = ((pp2->c>>10)&31);
  blue3 = ((pp3->c>>10)&31);

  dr1 = (red2-red1);
  dr2 = (red3-red2);
  dr3 = (red3-red1);
  dg1 = (green2-green1);
  dg2 = (green3-green2);
  dg3 = (green3-green1);
  db1 = (blue2-blue1);
  db2 = (blue3-blue2);
  db3 = (blue3-blue1);

  dxdy1 = ((dx1<<9)/dy1);
  dxdy2 = ((dx2<<9)/dy2);
  dxdy3 = ((dx3<<9)/dy3);

  drdy1 = ((dr1<<16)/dy1);
  drdy2 = ((dr2<<16)/dy2);
  drdy3 = ((dr3<<16)/dy3);
  dgdy1 = ((dg1<<16)/dy1);
  dgdy2 = ((dg2<<16)/dy2);
  dgdy3 = ((dg3<<16)/dy3);
  dbdy1 = ((db1<<16)/dy1);
  dbdy2 = ((db2<<16)/dy2);
  dbdy3 = ((db3<<16)/dy3);

  dsdata.x1 = (pp1->x<<9);
  dsdata.x2 = dsdata.x1;
  dsdata.red1 = (red1<<16);
  dsdata.red2 = dsdata.red1;
  dsdata.green1 = (green1<<16);
  dsdata.green2 = dsdata.green1;
  dsdata.blue1 = (blue1<<16);
  dsdata.blue2 = dsdata.blue1;
  dsdata.y1 = pp1->y;
  dsdata.y2 = pp2->y;
  dsdata.dxdy1 = dxdy1;
  dsdata.dxdy2 = dxdy3;
  dsdata.drdy1 = drdy1;
  dsdata.drdy2 = drdy3;
  dsdata.dgdy1 = dgdy1;
  dsdata.dgdy2 = dgdy3;
  dsdata.dbdy1 = dbdy1;
  dsdata.dbdy2 = dbdy3;

  DrawGSection15();
  dsdata.y1 = pp2->y;
  dsdata.y2 = pp3->y;
  dsdata.x1 = (pp2->x<<9);
  dsdata.red1 = (red2<<16);
  dsdata.green1 = (green2<<16);
  dsdata.blue1 = (blue2<<16);
  dsdata.dxdy1 = dxdy2;
  dsdata.dxdy2 = dxdy3;
  dsdata.drdy1 = drdy2;
  dsdata.drdy2 = drdy3;
  dsdata.dgdy1 = dgdy2;
  dsdata.dgdy2 = dgdy3;
  dsdata.dbdy1 = dbdy2;
  dsdata.dbdy2 = dbdy3;
  DrawGSection15();
}



// Internal function, don't call this one.
void DrawTSection8()
{
u32 y;
long x1,x2, tmp, dudx,dvdx;
long u1,u2, v1,v2;
u16 *dest,*last_dest;
long clipped;
  if (dsdata.y1>=RContext.height) return;
  if (dsdata.y2<0) return;

  if (dsdata.y1<0)  
  {
    clipped = 0-dsdata.y1;
    dsdata.x1 += (dsdata.dxdy1*clipped);
    dsdata.x2 += (dsdata.dxdy2*clipped);
    dsdata.u1 += (dsdata.dudy1*clipped);
    dsdata.u2 += (dsdata.dudy2*clipped);
    dsdata.v1 += (dsdata.dvdy1*clipped);
    dsdata.v2 += (dsdata.dvdy2*clipped);
    dsdata.y1 = 0;
  }
  if (dsdata.y2>=RContext.height) dsdata.y2 = (RContext.height-1);
  dest = ((u16 *)(RContext.buffer) + (dsdata.y1*RContext.width));

  for (y=dsdata.y1; y<=dsdata.y2; y++)  
  {
    if (dsdata.x1 <= dsdata.x2)
    {
      x1 = dsdata.x1;
      x2 = dsdata.x2;
      u1 = dsdata.u1;
      u2 = dsdata.u2;
      v1 = dsdata.v1;
      v2 = dsdata.v2;
    }else
    {
      x1 = dsdata.x2;
      x2 = dsdata.x1;
      u1 = dsdata.u2;
      u2 = dsdata.u1;
      v1 = dsdata.v2;
      v2 = dsdata.v1;
    }
    x1 >>= 9;
    x2 >>= 9;
    if ((x1<RContext.width)&&(x2>=0))
    {
      last_dest = dest;
      tmp = (x2-x1);
      if (tmp==0) tmp++;
      dudx = ((u2-u1)/tmp);
      dvdx = ((v2-v1)/tmp);
      dest += x1;
      __asm
      {
        mov r0,dest
        // to be written
      }
      dest = last_dest;
    } 
    if (y<dsdata.y2)
    {
      dest += RContext.width;
      dsdata.x1 += dsdata.dxdy1;
      dsdata.x2 += dsdata.dxdy2;
      dsdata.u1 += dsdata.dudy1;
      dsdata.u2 += dsdata.dudy2;
      dsdata.v1 += dsdata.dvdy1;
      dsdata.v2 += dsdata.dvdy2;
    }
  }
}

void TextureTriangle8(POINT *pp1, POINT *pp2, POINT *pp3)
{
}







// Set the rendering context.
void gbalRContext(void *buffer, u32 width, u32 height, u8 bitspp)
{
  RContext.buffer = (u8 *)(buffer);
  RContext.width = width;
  RContext.height = height;
  RContext.bitspp = bitspp;
  if (bitspp==15)
  {
    DrawSection = DrawSection15;
    GouraudTriangle = GouraudTriangle15;
  }else
  {
    GouraudTriangle = GouraudTriangle8;
    TextureTriangle = TextureTriangle8;
    DrawSection = DrawSection8;
  }
  gbalTriangle = Triangle;
}


void gbalShadeModel(u32 m)
{
  if (m==GBAL_FLAT)
  {
    gbalTriangle = Triangle;
  }else
  {
    gbalTriangle = GouraudTriangle;  
  }
}



void gbalSetMode(u32 wich)
{
  if ((wich>=1)||(wich<=6)) 
  {
    *(u32 *)(0x04000000) = wich;
  }
}


// I ripped this one from Eloist's wire-cube demo...
//
void gbalVSync()
{
  __asm
   {
    mov 	r0, #0x4000006
    scanline_wait:
     ldrh	r1, [r0]
     cmp	r1, #160
    bne 	scanline_wait
   }
}

u16 gbalMakeColor(int r, int g, int b)
{
  return (((r&248)>>3)|((g&248)<<2)|((b&248)<<7));
}


void gbalSetPalette(u32 wich, u16 *pal, int num_colors)
{
int i;
  if ((wich==BACKGROUND)||(wich==OBJECT))
  {
    for (i=0; i<num_colors; i++)
    {
      *(u16 *)(wich+i+i) = *(pal+i+i);
    }
  }
}


void gbalSetColor(u32 wich, int col_num, u16 col)
{
  if ((wich==BACKGROUND)||(wich==OBJECT))
  {
    *(u16 *)(wich+col_num+col_num) = col;
  }
}


void gbalTexImage2D(void *tex_addr, u32 tex_width, u32 tex_height)
{
  gbal_texture.texture = tex_addr;
  gbal_texture.width = tex_width;
  gbal_texture.height = tex_height;
}


void gbalEnable(u16 what)
{
  switch (what)
  {
    case GBAL_TEXTURE_2D:
      last_gbalTriangle = gbalTriangle;
      gbalTriangle = TextureTriangle;
      break;
    default:
      break;
  }
}


void gbalDisble(u16 what)
{
  switch (what)
  {
    case GBAL_TEXTURE_2D:
      gbalTriangle = last_gbalTriangle;
      break;
    default:
      break;
  }
}


 